-- Various constants used by the game.

BloxConstants =  {
   MODE_FALLING = 0,
   MODE_EXPLODE = 1, 
   
   MAX_SHAPE_ID  = 7, 
   NUM_SHAPES = 7, 
   NUM_BLOCK_GFX = 7,
   
   BLOX_SHAPE_OFFSETS = {
      {  1, 1, 1, 0 },
      {  1, 0, 1, 0 },
      {  1, 1, 1, 1 },
      {  1, 1, 1, 1 },
      {  1, 1, 1, 0 },
      {  1, 1, 1, 0 },
      {  1, 1, 1, 1 },
   }, 

   BLOX_SHAPE_MASKS = {
      {
	 {
	    { 1, 1, 1, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 } 
	 }, {
	    { 0, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 1, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 0, 1, 1, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 1, 0 }
	 },
      }, {
	 {
	    { 0, 0, 0, 0 },
	    { 1, 1, 1, 1 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 4, 1, 0, 1 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 1, 4, 1, 0 }
	 }, {
	    { 0, 0, 0, 0 },
	    { 1, 1, 1, 1 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 4, 1, 0, 1 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 1, 4, 1, 0 }
	 },
      }, {
	 {
	    { 1, 1, 0, 0 },
	    { 0, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 1, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }, {
	    { 1, 1, 0, 0 },
	    { 0, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 1, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }       
      }, {
	 {
	    { 0, 1, 1, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 1, 0, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }, {
	    { 0, 1, 1, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 1, 0, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 },
      }, {
	 {
	    { 0, 0, 0, 0 },
	    { 1, 1, 1, 0 },
	    { 1, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 1 }
	 }, {
	    { 1, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }, {
	    { 0, 0, 1, 0 },
	    { 1, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 1, 0 }
	 },
      }, {
	 {
	    { 0, 0, 0, 0 },
	    { 1, 1, 1, 0 },
	    { 0, 0, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 1 }
	 }, {
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 0, 0 }
	 }, {
	    { 1, 0, 0, 0 },
	    { 1, 1, 1, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 3, 2, 0, 0 }
	 }, {
	    { 0, 1, 1, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 3, 1, 0 }
	 },
      }, {
	 {
	    { 1, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 2, 0, 0 }
	 }, {
	    { 1, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 2, 0, 0 }
	 }, {
	    { 1, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 2, 0, 0 }
	 }, {
	    { 1, 1, 0, 0 },
	    { 1, 1, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 0, 0, 0, 0 },
	    { 2, 2, 0, 0 }
	 }
      }
   },
   GAME_OVER = {
      {1,1,1,1,1,1,1,1,1,1},
      {1,2,2,2,1,1,3,3,3,1},
      {1,2,1,1,1,1,3,1,3,1},
      {1,2,1,2,1,1,3,1,3,1},
      {1,2,2,2,1,1,3,3,3,1},
      {1,1,1,1,1,1,1,1,1,1},
      {1,2,2,2,1,1,3,1,3,1},
      {1,2,1,2,1,1,3,1,3,1},
      {1,2,2,2,1,1,3,1,3,1},
      {1,2,1,2,1,1,1,3,1,1},
      {1,1,1,1,1,1,1,1,1,1},
      {1,2,1,2,1,1,3,3,3,1},
      {1,2,2,2,1,1,3,1,1,1},
      {1,2,1,2,1,1,3,3,3,1},
      {1,2,1,2,1,1,3,1,1,1},
      {1,2,1,2,1,1,3,3,3,1},
      {1,1,1,1,1,1,1,1,1,1},
      {1,2,2,2,1,1,3,3,1,1},
      {1,2,1,1,1,1,3,1,3,1},
      {1,2,2,2,1,1,3,3,1,1},
      {1,2,1,1,1,1,3,1,3,1},
      {1,2,2,2,1,1,3,1,3,1},
      {1,1,1,1,1,1,1,1,1,1},
   },
   PAUSED = {
      {6,6,6,6,6,6,6,6,6,6},
      {6,6,6,2,2,2,6,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,2,2,2,6,6,6,6},
      {6,6,6,2,6,6,6,6,6,6},
      {6,6,6,2,6,6,6,6,6,6},
      {6,6,6,6,6,6,6,6,6,6},
      {6,6,6,6,2,2,6,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,2,2,2,2,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,6,6,6,6,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,2,6,6,2,6,6,6},
      {6,6,6,6,2,2,2,6,6,6},
      {6,6,6,6,6,6,6,6,6,6},
      {6,6,6,6,2,2,2,6,6,6},
      {6,6,6,2,6,6,6,6,6,6},
      {6,6,6,6,2,2,6,6,6,6},
      {6,6,6,6,6,6,2,6,6,6},
      {6,6,6,2,2,2,6,6,6,6},
      {6,6,6,6,6,6,6,6,6,6},
   },
   TEXTURES = {
      "Interface\\AddOns\\GravBlox\\img\\black", 
      "Interface\\AddOns\\GravBlox\\img\\blue", 
      "Interface\\AddOns\\GravBlox\\img\\green", 
      "Interface\\AddOns\\GravBlox\\img\\orange", 
      "Interface\\AddOns\\GravBlox\\img\\purple", 
      "Interface\\AddOns\\GravBlox\\img\\red", 
      "Interface\\AddOns\\GravBlox\\img\\white", 
   }   
}
